<?php

namespace Drupal\fxl_custom_block\Plugin\Block;

use Drupal\Core\Block\BlockBase;

/**
 * Provides a block with a simple text.
 *
 * @Block(
 *   id = "new_invoice_block",
 *   admin_label = @Translation("Custom Invoice Item detail"),
 * )
 */

class FxlcustomBlock extends BlockBase
{
    public function build()
    {
        $node = \Drupal::routeMatch()->getParameter('node');
        if ($node instanceof \Drupal\node\NodeInterface) {
            // You can get nid and anything else you need from the node object.
            $nid = $node->id();
        }

        $query = \Drupal::database()->select('invoice_details', 'invoice_details_alias');
        $query->fields('invoice_details_alias', ['item_description', 'quantity', 'price', 'id', 'tax', 'tax_amount', 'subtotal', 'grand_total']);
        $query->condition('node_id', $nid);
        $result = $query->execute();

        // echo 'nid is '.$nid.'<pre>';
        //  print_r($result->fetchAssoc());
        // echo '</pre>';
        //  exit();
        $is_view_block = false;
        if (!empty($result)) {
            $row_index = 0;
            $invoice_item_array = array();
            $subtotal = "";
            $tax = "";
            $tax_amount = "";
            $grand_total = "";
            while ($row = $result->fetchAssoc()) {
                $is_view_block = true;
                $invoice_item_array[$row_index]["item_description"] = $row["item_description"];
                $invoice_item_array[$row_index]["quantity"] = $row["quantity"];
                $invoice_item_array[$row_index]["price"] = $row["price"];
                $subtotal = $row["subtotal"];

                $tax = $row["tax"];
                $tax_amount = $row["tax_amount"];
                $grand_total = $row["grand_total"];
                if (!empty($row["quantity"]) && !empty($row["price"])) {
                    $invoice_item_array[$row_index]["total"] = $row["quantity"] * $row["price"];
                }


                $row_index += 1;
            }
            $item_list_html = '';
            $item_no_index = 1;
            foreach ($invoice_item_array as $item_index => $item_detail_array) {
                $item_total = "";
                if (!empty($item_detail_array["quantity"]) && !empty($item_detail_array["price"]))
                    $item_total = $item_detail_array["quantity"] * $item_detail_array["price"];

                $item_list_html .= '<tr id="addr0">
                <td>' . $item_no_index . '</td>
                <td>' . $item_detail_array["item_description"] . '</td>
                <td>' . $item_detail_array["quantity"] . '</td>
                <td>' . $item_detail_array["price"] . '</td>
                <td>' . $item_total . '</td>
            </tr>
            <tr id="addr1"></tr>';
                $item_no_index += 1;
            }

            if ($is_view_block == true) {
                $invoice_detail = '
                <div class="container">
            <div class="row clearfix">
                <div class="col-md-12">
                    <table class="table table-bordered table-hover" id="tab_logic">
                        <thead>
                            <tr>
                                <th class="text-center"> # </th>
                                <th class="text-center"> Product </th>
                                <th class="text-center"> Qty </th>
                                <th class="text-center"> Price </th>
                                <th class="text-center"> Total </th>
                            </tr>
                        </thead>
                        <tbody>
                           ' . $item_list_html . '
                        </tbody>
                    </table>
                </div>
            </div>
            <div class="row clearfix">
             
            </div>
            <div class="row clearfix" style="margin-top:20px">
                <div class="pull-right col-md-4">
                    <table class="table table-bordered table-hover" id="tab_logic_total">
                        <tbody>
                            <tr>
                            <th class="text-center">Sub Total</th>
                           
                                <td class="text-center">' . $subtotal . '</td>
                            </tr>
                            <tr>
                                <th class="text-center">Tax</th>
                                <td class="text-center">
                                    <div class="input-group mb-2 mb-sm-0">
                                        ' . $tax . '
                                        <div class="input-group-addon">%</div>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <th class="text-center">Tax Amount</th>
                                <td class="text-center"> ' . $tax_amount . '</td>
                            </tr>
                            <tr>
                                <th class="text-center">Grand Total</th>
                                <td class="text-center">' . $grand_total . '</td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
                ';
            }


            // echo '<br>num names is '.$num_names;
        } else {
        }





        return [
            '#type' => 'markup',
            '#markup'    => $invoice_detail
        ];
    }
    public function getCacheMaxAge()
    {
        return 0;
    }
}
